=== modified file 'bzrlib/benchmarks/bench_xml.py'
--- bzrlib/benchmarks/bench_xml.py	2006-08-16 21:31:49 +0000
+++ bzrlib/benchmarks/bench_xml.py	2006-08-16 21:38:23 +0000
@@ -28,7 +28,7 @@
         #                      with Robert's serializer:  631ms/10770ms
         #                      with Entity escaper:       487ms/11636ms
         #           caching Entity escaper, empty cache:  448ms/ 9489ms
-        #           caching Entity escaper, full cache:   381ms/ 9489ms
+        #           caching Entity escaper, full cache:   375ms/ 9489ms
         # Really all we want is a real inventory
         tree = self.make_kernel_like_committed_tree('.', link_bzr=True)
 

=== modified file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	2006-08-16 21:31:49 +0000
+++ bzrlib/xml5.py	2006-08-16 21:38:23 +0000
@@ -53,17 +53,11 @@
     This helps us remain compatible to older versions of bzr. We may change
     our policy in the future, though.
     """
-    # TODO: jam 20060816 Benchmark this, is it better to use try/except or
-    #       to use _map.get() and check for None.
-    #       Or still further, it might be better to pre-generate all
-    #       possible conversions. However, the occurance of unicode
-    #       characters is quite low, so an initial guess is that this
-    #       is the most efficient method
-    #       Also need to benchmark whether it is better to have a regex
-    #       which matches multiple characters, or if it is better to
-    #       only match a single character and call this function multiple
-    #       times. The chance that we actually need multiple escapes
-    #       is probably very low for our expected usage
+    # jam 20060816 Benchmarks show that try/KeyError is faster if you
+    # expect the entity to rarely miss. There is about a 10% difference
+    # in overall time. But if you miss frequently, then if None is much
+    # faster. For our use case, we *rarely* have a revision id, file id
+    # or path name that is unicode. So use try/KeyError.
     try:
         return _map[match.group()]
     except KeyError:
@@ -74,6 +68,8 @@
 
 def _encode_and_escape(unicode_str, _map=_unicode_to_escaped_map):
     """Encode the string into utf8, and escape invalid XML characters"""
+    # We frequently get entities we have not seen before, so it is better
+    # to check if None, rather than try/KeyError
     text = _map.get(unicode_str)
     if text is None:
         # The alternative policy is to do a regular UTF8 encoding

